<template>
    <div class="row">
        <div class="col-xxl">
            <div class="card mb-4">
                <div class="card-header pb-0">
                    <h4 class="mb-0">Địa chỉ của tôi</h4> <small class="text-muted">Quản lý địa chỉ để thuận tiện cho việc giao hàng</small>
                    <h5 v-if="updateSuccess" class="text-success">Cập nhật địa chỉ thành công</h5>
                    <hr>
                </div>
                <div class="card-body pt-1">
                    <form>
                        <div class="row mb-3">
                            <label class="col-sm-2 col-form-label" for="basic-default-company">Địa chỉ nhận hàng</label>
                            <div class="col-sm-10">
                                <input type="text" class="form-control" v-model="update.address" disabled />
                                <span class="text-danger"></span>
                            </div>
                        </div>
                        <div class="row justify-content-end">
                            <div class="col-sm-10">
                                <button type="button" ref="openModalAddr" data-toggle="modal" data-target="#modalAddress" class="btn btn-primary">Chỉnh sửa</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade" id="modalAddress" data-backdrop="static" tabindex="-1" role="dialog" aria-labelledby="modalAddress">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLongTitle">Thêm thông tin địa chỉ nhận hàng</h5>
                    <button type="button" v-on:click="closeModal()" class="btn" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form class="needs-validation" novalidate>
                        <div class="form-group mt-1">
                            <label for="city">Tỉnh/Thành phố</label>
                            <select @change="getDistrict()" v-model="formAddress.city" class="form-control" id="city" required>
                                <option value="">---Chọn Tỉnh/Thành phố---</option>
                                <template v-for="(item,index) in city" :key="index">
                                    <option :value="item">{{ item.name }}</option>
                                </template>
                            </select>
                            <div class="invalid-feedback">
                               Vui lòng chọn Tỉnh/Thành phố
                            </div>
                        </div>
                        <div class="form-group mt-1">
                            <label for="district">Quận/Huyện</label>
                            <select @change="getArea()" :disabled="!formAddress.city" v-model="formAddress.district" class="form-control" id="district" required>
                                <option value="">---Chọn Quận/Huyện---</option>
                                <template v-for="(item,index) in district" :key="index">
                                    <option :value="item">{{ item.name }}</option>
                                </template>
                            </select>
                            <div class="invalid-feedback">
                               Vui lòng chọn Quận/Huyện
                            </div>
                        </div>
                        <div class="form-group mt-1">
                            <label for="area">Xã/Phường/Thị trấn</label>
                            <select :disabled="!formAddress.city || !formAddress.district" v-model="formAddress.area" class="form-control" id="area" required>
                                <option value="">---Chọn Xã/Phường/Thị trấn---</option>
                                <template v-for="(item,index) in area" :key="index">
                                    <option :value="item">{{ item.name }}</option>
                                </template>
                            </select>
                            <div class="invalid-feedback">
                               Vui lòng chọn Xã/Phường/Thị trấn
                            </div>
                        </div>
                        <div class="form-group mt-1">
                            <label for="note">Địa chỉ chi tiết:</label>
                            <input v-model="formAddress.address_note" class="form-control" type="text" name="" id="note" required>
                            <div class="invalid-feedback">
                               Vui lòng nhập địa chỉ chi tiết
                            </div>
                        </div>
                        <div class="modal-footer pb-0">
                            <button v-on:click="closeModal()" ref="closeModalAddress" type="button" class="btn btn-secondary" data-dismiss="modal">Đóng</button>
                            <button type="button" v-on:click="saveAddress()" class="btn btn-primary">Lưu</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
 </template>
 
 <script>
    export default {
        name: 'info-address',
        data(){
            return {
                updateSuccess: false,
                city: null,
                district: null,
                area: null,
                formAddress: {
                    city: '',
                    district: '',
                    area: '',
                    address_note: '',
                    phone: '',
                    errors: []
                },
                update: {
                    name: '',
                    phone: '',
                    email: '',
                    address:''
                }
            }
        },
        props:{
            user: {
                type: Object,
                required: true
            }
        },
        methods:{
            closeModal(){
                this.formAddress = {
                    city: '',
                    district: '',
                    area: '',
                    address_note: '',
                    phone: '',
                    errors: []
                };
            },
            getCity(){
                this.$store.dispatch('listCity').then(res =>{
                    this.city = res.data;
                });
            },
            getDistrict(){
                if(!this.formAddress.city) return;
                this.formAddress.district = '';
                this.formAddress.area = '';
                this.$store.dispatch('listDistrict',{'city_code' : this.formAddress.city.city_code}).then(res =>{
                    this.district = res.data;
                });
            },
            getArea(){
                if(!this.formAddress.city || !this.formAddress.district) return;
                this.$store.dispatch('listArea',{'district_code' : this.formAddress.district.district_code}).then(res =>{
                    this.area = res.data;
                });
            },
            saveAddress(){
                var forms = document.querySelectorAll('.needs-validation');
                let error = false;
                Array.prototype.slice.call(forms).forEach(function (form) {
                    form.classList.add('was-validated');
                    error = !form.checkValidity();
                })
                if(error) return;
                this.update.address = this.formAddress.address_note 
                    + ', '+ this.formAddress.area.name 
                    + ', ' + this.formAddress.district.name 
                    + ', ' + this.formAddress.city.name;
                
                this.$refs.closeModalAddress.click();

                this.$store.dispatch('updateUser', this.update).then(res => {
                    this.updateSuccess = true;
                    setTimeout(() => {
                        this.updateSuccess = false;
                    }, 2000);
                });
            }
        },
        mounted() {;
            this.getCity();
            this.update.address = this.user.address;
            this.update.name = this.user.name;
            this.update.email = this.user.email;
            this.update.phone = this.user.phone;
        }
    }
 </script>
 <style lang="scss">
 
 </style>